/****************************************************************************/
/*  EmuZ-2000Xe[gZ[u c[                            */
/*--------------------------------------------------------------------------*/
/* `C`iŐV΂ɏׂjVersion (J).(ver)() */
/* H____ NH________ CT R_________________________________ */
/* 2022-01-05 Takky          Update   Version 1.12 G[̃_CAOC */
/* 2016-05-14 Takky          Update   Version 1.11 AhX͈͕\(bin)    */
/* 2015-01-25 Takky          Update   Version 1.10 Oh!X CRC_vXgΉ */
/* 2013-10-91 Takky          Update   Version 1.9 UNIXS-OS̃eLXgǍ  */
/* 2013-07-12 Takky          Update   Version 1.8 Oh!MZ`FbNT`Ή */
/* 2012-01-07 Takky          Update   Version 1.7 Ver9x Ή                */
/* 2011-09-28 Takky          Update   Version 1.6 AhXT̉Z@ύX*/
/* 2011-08-03 Takky          Update   Version 1.5 `FbNT2 */
/* 2011-03-22 Takky          Bugfix   Version 1.4 `FbNTȂ̕s*/
/* 2011-03-12 Takky          Update   Version 1.3 cTΉ                */
/* 2011-01-14 Takky          Bugfix   Version 1.2 fŃAhX͈̔͂\*/
/* 2011-01-13 Takky          Bugfix   Version 1.1 }Ci[oOׂ          */
/* 2010-12-13 Takky          Coding   Version 1.0 J                */
/****************************************************************************/

/**  CN[ht@C  **/
#include <windows.h>			//  ͕K{
#include <commdlg.h>			//  t@CQƂŎg
#include <shellapi.h>			//  Drag & Drop
#include <stdio.h>				//  sprintfgĂ邩˥
#include <stdlib.h>				//  CCugpĂ邽߁B
#include <string.h>				//  XgO삪邩
#include <alloc.h>				//  [݂gĂ܂
#include <errno.h>				//  G[pgĂȂ
#include <ctype.h>				//  Kv
#include <dir.h>				//  fnsplit֐p

#include "emzedt.h"
#define	MZEHEADSIZE		16		// ςύXׂ  2012-01-07 add
#include "../emuz2000src/MZ2000/mz2000.h"	//pX͍킹 2012-01-07 add
#define	Z80INFOSIZE		(sizeof(unsigned int)+sizeof(Z80))	// 2012-01-07 add
#define	MZ2000INFOSIZE	(sizeof(unsigned int)+sizeof(MZ2000)) // 2012-01-07 add
#define	MZIOINFOSIZE	(sizeof(unsigned int)+sizeof(MZIOInfo)) // 2012-01-07 add
#define	SKIPSIZE		(MZEHEADSIZE+Z80INFOSIZE+MZ2000INFOSIZE+MZIOINFOSIZE) //2012-01-07 add

#define	TITLE_LINE	"EmuZ-2000Xe[gZ[u c["
HANDLE	hInst;
static HGLOBAL hMem;
static char *cpStateBuffer = NULL;
static long lStateSize = 0;
static RECT rctEdit1, rctEdit2;
static int	iSkipSize;	// 2012-01-07 add
static int	bIsCheck;	// 2012-01-07 add
static char mbuf[512];	// 2022-01-05 add

static int isHex(char *);
static int isAddr(char *);
static void upper(char *, char *);
static int CheckEmz(char *);
static void ReadSateFile(const char *);
static void BinaryProc(const char *, const char *, int);
//2022-01-05 del static void TextProc(const char *, int , int, int, int, int);
static void TextProc(HWND, const char *, int , int, int, int, int); // 2022-01-05 add
static void RewriteStateFile(const char *);
int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
DWORD FAR PASCAL MainProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK _export About(HWND, unsigned, WORD, LONG);
BOOL CALLBACK _export MessageProc(HWND, unsigned, WORD, LONG); // 2022-01-05 add

static int isHex(char *buf)
{
	if ((((*buf >='0') && (*buf <='9')) || ((*buf >='A') && (*buf <='F'))) &&
		(((*(buf+1) >='0') && (*(buf+1) <='9')) || ((*(buf+1) >='A') && (*(buf+1) <='F'))))
		return 1;
	else
		return 0;
}

static int isAddr(char *buf)
{
	if ((((*buf >='0') && (*buf <='9')) || ((*buf >='A') && (*buf <='F'))) &&
		(((*(buf+1) >='0') && (*(buf+1) <='9')) || ((*(buf+1) >='A') && (*(buf+1) <='F'))) &&
		(((*(buf+2) >='0') && (*(buf+2) <='9')) || ((*(buf+2) >='A') && (*(buf+2) <='F'))) &&
		(((*(buf+3) >='0') && (*(buf+3) <='9')) || ((*(buf+3) >='A') && (*(buf+3) <='F'))))
		return 1;
	else
		return 0;
}

static void upper(char *dst, char *src)
{
	while (*src) {
		*dst = toupper(*src);
		dst++;
		src++;
	}
}

static int CheckEmz(char *cp)
{
	if (memcmp(cp, "EMUZ", 4) != 0) return 1; /* ID error */
	if (*(cp+5) != 0x00) return 1;            /* reserved must be zero */
	if (*(cp+4) != 0x01) return 1;            /* type must be 1 */
//2012-01-07 del	if (*(cp+6) != 0x00) return 1;            /* sub version must be 0 */
//2012-01-07 del	if (*(cp+7) != 0x00) return 1;            /* version must be 0 */
	return 0;
}

static void ReadSateFile(const char *szFileName)
{
HANDLE hFile;
DWORD dwSize, dwErr, dwReadSize;
char buf[256];

	if (cpStateBuffer != NULL) {
		GlobalUnlock(hMem);
		GlobalFree(hMem);
		cpStateBuffer = NULL;
	}
	if ((hFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		MessageBox(NULL, "Xe[gZ[uf[^I[vł܂BgpAANZXȂǂ̊mFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((dwSize = GetFileSize(hFile, NULL)) == 0xffffffff) {
		dwErr = GetLastError();
		if (dwErr != NO_ERROR) {
			memset(buf, 0x00, sizeof(buf));
			snprintf(buf, sizeof(buf), "Xe[gZ[uf[^̃TCY擾ŃG[܂(%d)", dwErr);
			MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return;
		}
	}
	lStateSize = dwSize;
	if ((hMem = GlobalAlloc(GMEM_FIXED, dwSize)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "Xe[gZ[uf[^i[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((cpStateBuffer = (char *)GlobalLock(hMem)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "Xe[gZ[uf[^i[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalFree(hMem);
		CloseHandle(hFile);
		return;
	}
	ReadFile(hFile, cpStateBuffer, dwSize, &dwReadSize, NULL);
	if (lStateSize != (long)dwReadSize) {
		MessageBox(NULL, "Xe[gZ[uf[^ǂݍ߂܂ł", TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalUnlock(hMem);
		GlobalFree(hMem);
		CloseHandle(hFile);
		return;
	}
	CloseHandle(hFile);
}

static void BinaryProc(const char *szFileName, const char *saddr, int bUnixText)
{
long lStartAddr;
long lsAdr, leAdr; /* 2016-05-14 add */
HANDLE hFile;
HGLOBAL hMem2;
DWORD dwSize, dwErr, dwReadSize;
char buf[256], *cpDumpBuffer;
char *dst, *src;

	lStartAddr = strtol(saddr, NULL, 16);
	if ((hFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		MessageBox(NULL, "_vt@CI[vł܂BgpAANZXȂǂ̊mFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((dwSize = GetFileSize(hFile, NULL)) == 0xffffffff) {
		dwErr = GetLastError();
		if (dwErr != NO_ERROR) {
			memset(buf, 0x00, sizeof(buf));
			snprintf(buf, sizeof(buf), "_vt@C̃TCY擾ŃG[܂(%d)", dwErr);
			MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return;
		}
	}
	if ((lStartAddr + dwSize) >= 65536) {
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@C傫邩JnAhX傫܂B\n_vt@CTCY:%d",
			dwSize);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((hMem2 = GlobalAlloc(GMEM_FIXED, dwSize)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@Ci[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((cpDumpBuffer = (char *)GlobalLock(hMem2)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@Ci[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalFree(hMem2);
		CloseHandle(hFile);
		return;
	}
	ReadFile(hFile, cpDumpBuffer, dwSize, &dwReadSize, NULL);
	if (dwSize != dwReadSize) {
		MessageBox(NULL, "_vt@Cǂݍ߂܂ł", TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalUnlock(hMem2);
		GlobalFree(hMem2);
		CloseHandle(hFile);
		return;
	}
	CloseHandle(hFile);

// 2012-01-07 change	lStartAddr += 4096; /* Xe[gZ[uf[^̃C[WAhX܂ŃXLbv */
	lsAdr = lStartAddr; /* 2016-05-14 add */
	leAdr = lStartAddr + dwSize - 1; /* 2016-05-14 add */
	lStartAddr += iSkipSize; /* Xe[gZ[uf[^̃C[WAhX܂ŃXLbv */
	if (bUnixText == 0)
		memcpy((cpStateBuffer+lStartAddr), cpDumpBuffer, dwSize);
	else {
		dst = (cpStateBuffer+lStartAddr);
		src = cpDumpBuffer+18; /* UNIXpwb_̍폜 */
		leAdr -= 18; /* 2016-05-14 add */
		while (dwSize > 0) {
			if (*src == 0x0a)
				*dst = 0x0d;   /* LF->CR */
			else
				*dst = *src;
			dst++;
			src++;
			dwSize--;
		}
		*dst = 0x00; /* NULL } */
	}
	GlobalUnlock(hMem2);
	GlobalFree(hMem2);
	/* 2016-05-14 add start */
	memset(buf, 0x00, sizeof(buf));
	snprintf(buf, sizeof(buf), "܂\nAhX:$%04X - $%04X", lsAdr, leAdr);
	MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONINFORMATION);
	/* 2016-05-14 add end */
}

#pragma warn -8004
//2022-01-05 del static void TextProc(const char *szFileName, int bSum, int bAddSum, int bLowOnly, int bOhMZsum, int bCRC)
static void TextProc(HWND hWnd, const char *szFileName, int bSum, int bAddSum, int bLowOnly, int bOhMZsum, int bCRC)
{
FILE *fp;
char rbuf[1024], cbuf[1024], buf[512], *cp, tmp[16];
long iSum, iVSum[16], iASum;
char adr[5], data[17][4];
unsigned char wbuf[16];
int iNum, i, j, isErr, iNum2, iNum3;
long lStartAddr, cdata, lsAdr, leAdr;
int clen;
char mzsum[4], mzvsum[5];
unsigned short crcSum;
unsigned char crcData;

	if ((fp = fopen(szFileName, "r")) == NULL) {
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@CI[vł܂(%d)", errno);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		return;
	}
	lsAdr = 65536;
	leAdr = 0;
	iSum = 0;
	iASum = 0;
	isErr = 0;
	crcSum = 0;
	memset((void *)iVSum, 0x00, sizeof(iVSum)); /* 20110312 */
	memset(rbuf, 0x00, sizeof(rbuf));
	memset(cbuf, 0x00, sizeof(cbuf));
	while (fgets(rbuf, sizeof(rbuf), fp) != NULL) {
		if (strlen(rbuf) <=3) continue;
		upper(cbuf, rbuf);
		if (isAddr(cbuf)) {
			cp = strtok(cbuf, " \n");
			strncpy(adr, cp, 5);
			iNum = 0;
			while ((cp = strtok(NULL, " \n")) != NULL) {
				if ((clen = strlen(cp)) <= 2)
					strncpy(data[iNum], cp , 3);
				else {
					if (bOhMZsum == 1) {
						memset(mzsum, 0x00, sizeof(mzsum));
						data[iNum][0] = *(cp+1);
						strncpy(&data[iNum][1], (cp+3) , 2);
					} else {
						strncpy(data[iNum], (cp+clen-2) , 3);
					}
				}
				if (bCRC == 1) {
					/* Oh!XCRC^Cv̏ꍇA:̎ɃXy[X̂Ŗ */
					if (data[iNum][0] == ':')
						;
					else
						iNum++;
				} else
					iNum++;
				if (iNum > 16) break;
			}
			lStartAddr = strtol(adr, NULL, 16);
			if (lStartAddr >= 0 || lStartAddr <= 65535) {
				for (i=0; i<(bSum == 1 ? iNum-1 : iNum); i++) {
					/* 20110311 add */
					if (!isHex(data[i])) {
						fclose(fp);
						memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
//2022-01-05 del		memset(buf, 0x00, sizeof(buf));
//2022-01-05 del		snprintf(buf, sizeof(buf), "f[^G[\n@OAhX:%s\n@ItZbg:%02X\n@f[^:%s", adr, i, data[i]);
//2022-01-05 del		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						// 2022-01-05 add start
						snprintf(mbuf, sizeof(mbuf), "f[^G[\r\n@OAhX:%s\r\n@ItZbg:%02X\r\n@f[^:%s\r\n(E00)", adr, i, data[i]);
						DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc);
						// 2022-01-05 add end
						return;
					}
					/* 20110311 end add */
					cdata = strtol(data[i], NULL, 16);
					iSum += cdata;
					wbuf[i] = (unsigned char)cdata;
					iVSum[i] += cdata;
					iASum += cdata;
					if (bCRC == 1) {
						crcData = cdata;
						for (j=0; j<8; j++) {
							if ((crcSum & 0x8000) != 0) {
								crcSum = crcSum << 1;
								crcSum = crcSum ^ 0x1021;
							} else {
								crcSum = crcSum << 1;
							}
							if ((crcData & 0x80) != 0) {
								crcData = crcData << 1;
								crcSum = crcSum ^ 0x0001;
							} else {
								crcData = crcData << 1;
							}
						}
					}
				}
				if (bSum == 1) {
/* 2011-09-28 change
					if (bAddSum == 1)
						iSum += ((lStartAddr & 0x000000ff) + ((lStartAddr >> 8) & 0x000000ff));
 */
					if (bAddSum == 1) {
						if (bLowOnly == 1)
							iSum += (lStartAddr & 0x000000ff);
						else
							iSum += ((lStartAddr & 0x000000ff) + ((lStartAddr >> 8) & 0x000000ff));
					}
					/* 2013-07-12 add */
					if (bOhMZsum == 1) {
						iSum = iSum & 0x00000fff;
					} else {
						iSum = iSum & 0x000000ff;
					} /* 2013-07-12 */
					if (iSum != strtol(data[iNum-1], NULL, 16)) {
						fclose(fp);
						memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
// 2022-01-05 del		memset(buf, 0x00, sizeof(buf));
						if (bOhMZsum == 1) {
// 2022-01-05 del			snprintf(buf, sizeof(buf), "`FbNTG[\n@AhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%03X", adr, data[iNum-1], iSum);
							snprintf(mbuf, sizeof(mbuf), "`FbNTG[\r\n@AhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%03X\r\n(E02)", adr, data[iNum-1], iSum); // 2022-01-05 add
						} else {
// 2022-01-05 del			snprintf(buf, sizeof(buf), "`FbNTG[\n@AhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%02X", adr, data[iNum-1], iSum);
							snprintf(mbuf, sizeof(mbuf), "`FbNTG[\r\n@AhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%02X\r\n(E03)", adr, data[iNum-1], iSum); // 2022-01-05 add
						}
// 2022-01-05 del		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
						return;
					}
				}
				if (lsAdr > lStartAddr) lsAdr = lStartAddr;
				if (leAdr < (lStartAddr+(bSum == 1 ? iNum-2 : iNum-1)))
					leAdr = (lStartAddr+(bSum == 1 ? iNum-2 : iNum-1));
/* 2012-01-07 change				lStartAddr += 4096; /* Xe[gZ[uf[^̃C[WAhX܂ŃXLbv */
				lStartAddr += iSkipSize; /* Xe[gZ[uf[^̃C[WAhX܂ŃXLbv */
				memcpy((cpStateBuffer+lStartAddr), wbuf, (bSum == 1 ? iNum-1 : iNum));
			}
		/* 20110311 add */
		} else if (bSum == 1 && memcmp(cbuf, "SUM", 3) == 0) {
			cp = strtok(cbuf, " \n");
// 2022-01-05 del			memset(buf, 0x00, sizeof(buf));
// 2022-01-05 del			snprintf(buf, sizeof(buf), "c`FbNTG[\n@OAhX:%s\n", adr);
			memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
			snprintf(mbuf, sizeof(mbuf), "c`FbNTG[\r\n@OAhX:%s\r\n", adr); // 2022-01-05 add
			iNum3 = 0;
			while (cp != NULL) {
				cp = strtok(NULL, " \n");
				if (cp != NULL && strlen(cp) == 2)
					iNum3++;
			}
			upper(cbuf, rbuf);
			cp = strtok(cbuf, " \n");
			for (iNum2 = 0; iNum2 < iNum3; iNum2++) {
				cp = strtok(NULL, " \n");
				if (!isHex(cp)) {
					fclose(fp);
// 2022-01-05 del					memset(buf, 0x00, sizeof(buf));
// 2022-01-05 del					snprintf(buf, sizeof(buf), "`FbNTf[^G[\n@OAhX:%s\n@ItZbg:+%02X\n@f[^:%s", adr, iNum2, cp);
// 2022-01-05 del					MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
					memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
					snprintf(mbuf, sizeof(mbuf), "`FbNTf[^G[\r\n@OAhX:%s\r\n@ItZbg:+%02X\r\n@f[^:%s\r\n(E04)", adr, iNum2, cp); // 2022-01-05 add
					DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
					return;
				}
				if ((iVSum[iNum2] & 0x00ff) != strtol(cp, NULL, 16)) {
// 2022-01-05 del					strcat(buf, "@@+");
					strcat(mbuf, "@@+"); // 2022-01-05 add
					memset(tmp, 0x00, sizeof(tmp));
					tmp[0] = (char)(((iNum2 < 10) ? iNum2+0x30 : iNum2+0x37) & 0x00ff);
// 2022-01-05 del					strcat(buf, tmp);
// 2022-01-05 del					strcat(buf, "@");
// 2022-01-05 del					strcat(buf, cp);
					strcat(mbuf, tmp); // 2022-01-05 add
					strcat(mbuf, "@"); // 2022-01-05 add
					strcat(mbuf, cp); // 2022-01-05 add
					memset(tmp, 0x00, sizeof(tmp));
					snprintf(tmp, sizeof(tmp), "/%02X\n", (iVSum[iNum2] & 0x00ff));
// 2022-01-05 del					strcat(buf, tmp);
					strcat(mbuf, tmp); // 2022-01-05 add
					isErr = 1;
				}
			}
			if (isErr) {
				fclose(fp);
// 2022-01-05 del				MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
				strcat(mbuf, "\r\n(E05)"); // 2022-01-05 add
				DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
				return;
			} else {
				cp = strtok(NULL, " \n");
				memset(tmp, 0x00, sizeof(tmp));
				if (bCRC == 0) {
					if ((clen = strlen(cp)) <= 2) /* 2011-09-28 debug */
						strncpy(tmp, cp , 3);
					else
						strncpy(tmp, (cp+clen-2) , 3); /* 2011-09-28 debug */
					if ((iASum & 0x00ff) != strtol(tmp, NULL, 16)) {
						fclose(fp);
// 2022-01-05 del						memset(buf, 0x00, sizeof(buf));
// 2022-01-05 del						snprintf(buf, sizeof(buf), "c`FbNTG[\n@OAhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%02X", adr, tmp, (iASum & 0x00ff));
// 2022-01-05 del						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
						snprintf(mbuf, sizeof(mbuf), "c`FbNTG[\r\n@OAhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%02X\r\n(E06)", adr, tmp, (iASum & 0x00ff)); // 2022-01-05 add
						DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
						return;
					}
				} else {
					strncpy(tmp, cp , 4);
					if (crcSum != strtol(tmp, NULL, 16)) {
						fclose(fp);
// 2022-01-05 del						memset(buf, 0x00, sizeof(buf));
// 2022-01-05 del						snprintf(buf, sizeof(buf), "bqbG[\n@OAhX:%s\n@wbqb:%s\n@Zobqb:%04X", adr, tmp, crcSum);
// 2022-01-05 del						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
						snprintf(mbuf, sizeof(mbuf), "bqbG[\r\n@OAhX:%s\r\n@wbqb:%s\r\n@Zobqb:%04X\r\n(E07)", adr, tmp, crcSum); // 2022-01-05 add
						DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
						return;
					}
				}
			}
			isErr = 0;
			iASum = 0;
			crcSum = 0;
			memset((void *)iVSum, 0x00, sizeof(iVSum)); /* 20110312 */
		} else if (bOhMZsum == 1 && memcmp(cbuf, "------------------------------", 30) == 0) {
			memset(mzvsum, 0x00, sizeof(mzvsum));
			memcpy(mzvsum, &cbuf[strlen(cbuf)-5], 4);
			if ((iASum & 0xffff) != strtol(mzvsum, NULL, 16)) {
				fclose(fp);
// 2022-01-05 del				memset(buf, 0x00, sizeof(buf));
// 2022-01-05 del				snprintf(buf, sizeof(buf), "c`FbNTG[\n@OAhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%04X", adr, mzvsum, (iASum & 0xffff));
// 2022-01-05 del				MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
				memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
				snprintf(mbuf, sizeof(mbuf), "c`FbNTG[\r\n@OAhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%04X\r\n(E08)", adr, mzvsum, (iASum & 0xffff)); // 2022-01-05 add
				DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
				return;
			}
			isErr = 0;
			iASum = 0;
			memset((void *)iVSum, 0x00, sizeof(iVSum)); /* 20110312 */
		}
		iSum = 0;
		memset(rbuf, 0x00, sizeof(rbuf));
		memset(cbuf, 0x00, sizeof(cbuf));
	}
	fclose(fp);
	memset(buf, 0x00, sizeof(buf));
	snprintf(buf, sizeof(buf), "܂\nAhX:$%04X - $%04X", lsAdr, leAdr);
	MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONINFORMATION);
}
#pragma warn .8004

static void RewriteStateFile(const char *FileName)
{
HANDLE hFile;
DWORD dwWriteBytes;
char szNewFile[MAX_PATH];

	strncpy(szNewFile, FileName, MAX_PATH);
	strcat(szNewFile, ".old");
	MoveFile(FileName, szNewFile);
	if ((hFile = CreateFile(FileName, GENERIC_WRITE, 0, NULL,
		OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		MessageBox( NULL, "Xe[gZ[uf[^I[vł܂BgpAANZXȂǂ̊mFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	WriteFile(hFile, cpStateBuffer, lStateSize, &dwWriteBytes, NULL);
	if ((long)dwWriteBytes != lStateSize) {
		MessageBox(NULL, "Xe[gZ[ue𐳏ɏ߂܂łB", TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	CloseHandle(hFile);
}

/** CCallback֐ **/
#pragma warn -par
DWORD FAR PASCAL MainProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
static char szSaveFileName[MAX_PATH];
static char szDumpFileName[MAX_PATH];
static char szDropFileName[MAX_PATH];
static int	bType = 0;
static int	bSum = 1;
static int	bAddSum = 0;
static int	bLowOnly = 0;	/* 2011-09-28 add */
static int	bOhMZsum = 0;	/* 2013-07-12 add */
static int	bUnixText = 0;	/* 2013-10-01 add */
static char szStartAddr[5];
static int	bCRC = 0;	/* 2015-01-24 add */
OPENFILENAME	OFN;
char	Filter[256], szCurDir[MAX_PATH], buf[512];
int	sPos, tmp;
POINT ptDrop;
DWORD err;

	switch (message) {
/** _CAȌ **/
		case WM_INITDIALOG:
			GetWindowRect(GetDlgItem(hWnd, IDC_EDIT1), &rctEdit1);
			GetWindowRect(GetDlgItem(hWnd, IDC_EDIT2), &rctEdit2);
			DragAcceptFiles(hWnd, TRUE);
			memset(szSaveFileName, 0x00, sizeof(szSaveFileName));
			memset(szDumpFileName, 0x00, sizeof(szDumpFileName));
			if (bType == 0)
				CheckRadioButton(hWnd, IDC_RADIOBUTTON1, IDC_RADIOBUTTON2,
					IDC_RADIOBUTTON1);
			else
				CheckRadioButton(hWnd, IDC_RADIOBUTTON1, IDC_RADIOBUTTON2,
					IDC_RADIOBUTTON2);
			if (bSum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX1, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX1, TRUE);
			if (bAddSum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX2, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX2, TRUE);
			if (bLowOnly == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX3, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX3, TRUE);
			if (bOhMZsum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX5, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX5, TRUE);
			CheckDlgButton(hWnd, IDC_CHECKBOX4, TRUE);
			bIsCheck = 1;
			SetDlgItemInt(hWnd, IDC_EDIT4, SKIPSIZE, FALSE); // 2012-01-07 add
			/* 2015-01-24 add */
			if (bCRC == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX7, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX7, TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX1), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX2), TRUE);
			if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
				EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), TRUE);
			else
				EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX5), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX7), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX6), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_BUTTON4), FALSE);
			break;

/** t@C̃hbv **/
		case WM_DROPFILES:
			/* 2012-01-01 add */
			if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX4))
				bIsCheck = 1;
			else
				bIsCheck = 0;
					/* 2012-01-01 add end */
			/* hbvꂽt@C1ڂ̗pă_CAO֏o */
			DragQueryPoint((HDROP)wParam, &ptDrop);
			DragQueryFile((HDROP)wParam, 0, szDropFileName, MAX_PATH);
			DragFinish((HDROP)wParam);
			ptDrop.y += GetSystemMetrics(SM_CYCAPTION);
			/* Xe[gZ[uf[^̃hbv͈̓`FbNBQƃ{^̈ʒuGfBbg{bNX܂ */
			if ((ptDrop.x >= rctEdit1.left && ptDrop.x <= rctEdit1.right) &&
				(ptDrop.y >= rctEdit1.top && ptDrop.y <= rctEdit1.bottom)) {
				if (strlen(szSaveFileName) != 0 && strcmp(szSaveFileName, szDropFileName) != 0) {
					if (MessageBox(NULL, "Xe[gZ[uf[^u܂H", TITLE_LINE, MB_YESNO | MB_ICONQUESTION) == IDCANCEL)
						break;
				}
				SetDlgItemText(hWnd, IDC_EDIT1, szDropFileName);
				strcpy(szSaveFileName, szDropFileName);
				ReadSateFile(szSaveFileName);
				if (bIsCheck && CheckEmz(cpStateBuffer)) // 2012-01-02 change
					MessageBox(NULL, "Xe[gZ[uf[^s̉\܂B\nɏȂ\܂B", TITLE_LINE, MB_OK | MB_ICONEXCLAMATION);
				InvalidateRect(hWnd, NULL, TRUE);
			}
			/* _vt@C̃hbv͈̓`FbNBQƃ{^̈ʒuGfBbg{bNX܂ */
			if ((ptDrop.x >= rctEdit2.left && ptDrop.x <= rctEdit2.right) &&
				(ptDrop.y >= rctEdit2.top && ptDrop.y <= rctEdit2.bottom)) {
				SetDlgItemText(hWnd, IDC_EDIT2, szDropFileName);
				strcpy(szDumpFileName, szDropFileName);
				InvalidateRect(hWnd, NULL, TRUE);
			}
			break;

		// {^ñR}h
		case WM_COMMAND:
			switch(wParam) {
				case IDC_RADIOBUTTON1:
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX1), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX2), TRUE);
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), TRUE);
					else
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX5), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX7), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX6), FALSE);
					break;

				case IDC_RADIOBUTTON2:
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX1), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX2), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX5), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX7), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX6), TRUE);
					break;

				case IDC_CHECKBOX2:
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), TRUE);
					else
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
					break;

				case IDC_BUTTON1:	// Xe[gZ[uQ
					/* 2012-01-01 add */
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX4))
						bIsCheck = 1;
					else
						bIsCheck = 0;
					/* 2012-01-01 add end */
					/* J_CAOoăt@CIĂ炤 */
					memset(szCurDir, 0x00, sizeof(szCurDir));
					memset(&OFN, 0x00, sizeof(OFN));
					memset(Filter, 0x00, sizeof(Filter));
					strcpy(Filter, "Xe[gZ[uf[^ (*.mze)");
					sPos = strlen(Filter);
					strcpy(&Filter[sPos+1], "*.mze");
					OFN.lStructSize = sizeof(OPENFILENAME);
					OFN.hwndOwner = hWnd;
					OFN.hInstance = hInst;
					OFN.lpstrFilter = Filter;
					OFN.lpstrCustomFilter = NULL;
					OFN.nMaxCustFilter = 0;
					OFN.nFilterIndex = 0;
					OFN.lpstrFile = szCurDir;
					OFN.nMaxFile = sizeof(szCurDir);
					OFN.lpstrInitialDir = NULL;
					OFN.lpstrFileTitle = NULL;
					OFN.nMaxFileTitle = 0;
					OFN.lpstrTitle = "Xe[gZ[uf[^t@C̑I";
					OFN.nFileOffset = 0;
					OFN.nFileExtension = 0;
					OFN.lpstrDefExt = NULL;
					OFN.lCustData = NULL;
					OFN.lpfnHook = NULL;
					OFN.lpTemplateName = NULL;
					OFN.Flags = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
					if (GetOpenFileName(&OFN)) {
						SetDlgItemText(hWnd, IDC_EDIT1, OFN.lpstrFile);
						strcpy(szSaveFileName, OFN.lpstrFile);
						ReadSateFile(szSaveFileName);
						if (bIsCheck && CheckEmz(cpStateBuffer)) // 2012-01-02 change
							MessageBox(NULL, "Xe[gZ[uf[^s̉\܂B\nɏȂ\܂B", TITLE_LINE, MB_OK | MB_ICONEXCLAMATION);
						InvalidateRect(hWnd, NULL, TRUE);
//					} else {
//						err = CommDlgExtendedError();
//						memset(buf, 0x00, sizeof(buf));
//						snprintf(buf, sizeof(buf), "result: %04x", err);
//						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
					}
					/* _CAOLZꂽ牽Ȃ */
					break;

				case IDC_BUTTON2:	// _vt@CQ
					/* J_CAOoăt@CIĂ炤 */
					memset(szCurDir, 0x00, sizeof(szCurDir));
					memset(&OFN, 0x00, sizeof(OFN));
					memset(Filter, 0x00, sizeof(Filter));
					strcpy(Filter, "_vt@C (*.*)");
					sPos = strlen(Filter);
					strcpy(&Filter[sPos+1], "*.*");
					OFN.lStructSize = sizeof(OPENFILENAME);
					OFN.hwndOwner = hWnd;
					OFN.hInstance = hInst;
					OFN.lpstrFilter = Filter;
					OFN.lpstrCustomFilter = NULL;
					OFN.nMaxCustFilter = 0;
					OFN.nFilterIndex = 0;
					OFN.lpstrFile = szCurDir;
					OFN.lpstrInitialDir = NULL;
					OFN.nMaxFile = sizeof(szCurDir);
					OFN.lpstrFileTitle = NULL;
					OFN.nMaxFileTitle = 0;
					OFN.lpstrTitle = "_vt@C̑I";
					OFN.nFileOffset = 0;
					OFN.nFileExtension = 0;
					OFN.lpstrDefExt = NULL;
					OFN.lCustData = NULL;
					OFN.lpfnHook = NULL;
					OFN.lpTemplateName = NULL;
					OFN.Flags = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
					if (GetOpenFileName(&OFN)) {
						SetDlgItemText(hWnd, IDC_EDIT2, OFN.lpstrFile);
						strcpy(szDumpFileName, OFN.lpstrFile);
						InvalidateRect(hWnd, NULL, TRUE);
//					} else {
//						err = CommDlgExtendedError();
//						memset(buf, 0x00, sizeof(buf));
//						snprintf(buf, sizeof(buf), "result: %04x", err);
//						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
					}
					/* _CAOLZꂽ牽Ȃ */
					break;

				case IDC_BUTTON3:	// _vf
//					memset(szSaveFileName, 0x00, sizeof(szSaveFileName));
//					GetDlgItemText(hWnd, IDC_EDIT1, szSaveFileName, sizeof(szSaveFileName));
//					memset(szDumpFileName, 0x00, sizeof(szDumpFileName));
//					GetDlgItemText(hWnd, IDC_EDIT2, szDumpFileName, sizeof(szDumpFileName));
					if (cpStateBuffer != NULL) {
						ReadSateFile(szSaveFileName);
						if (bIsCheck && CheckEmz(cpStateBuffer)) // 2012-01-02 change
							MessageBox(NULL, "Xe[gZ[uf[^s̉\܂B\nɏȂ\܂B", TITLE_LINE, MB_OK | MB_ICONEXCLAMATION);
					}
					if (strlen(szSaveFileName) == 0) {
						MessageBox(NULL, "Xe[gZ[uf[^w肵ĂB", TITLE_LINE, MB_OK | MB_ICONSTOP);
						break;
					}
					if (strlen(szDumpFileName) == 0) {
						MessageBox(NULL, "_vt@Cw肵ĂB", TITLE_LINE, MB_OK | MB_ICONSTOP);
						break;
					}
					if (IsDlgButtonChecked(hWnd, IDC_RADIOBUTTON1))
						bType = 0;
					else
						bType = 1;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX1))
						bSum = 1;
					else
						bSum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX6))
						bUnixText = 1;
					else
						bUnixText = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						bAddSum = 1;
					else
						bAddSum = 0;
				/* 2013-07-10 Add start */
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX5))
						bOhMZsum = 1;
					else
						bOhMZsum = 0;
				/* 2013-07-10 Add end */
				/* 2011-09-28 Add */
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX3))
						bLowOnly = 1;
					else
						bLowOnly = 0;
				/* 2015-01-24 add */
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX7))
						bCRC = 1;
					else
						bCRC = 0;
					memset(szStartAddr, 0x00, sizeof(szStartAddr));
					GetDlgItemText(hWnd, IDC_EDIT3, szStartAddr, 5);
					iSkipSize = GetDlgItemInt(hWnd, IDC_EDIT4, NULL, NULL); // 2012-01-07 add
					if (bType == 1) {
						BinaryProc(szDumpFileName, szStartAddr, bUnixText);
					} else {
//2022-01-05 del						TextProc(szDumpFileName, bSum, bAddSum, bLowOnly, bOhMZsum, bCRC);
						TextProc(hWnd, szDumpFileName, bSum, bAddSum, bLowOnly, bOhMZsum, bCRC);
					}
					EnableWindow(GetDlgItem(hWnd, IDC_BUTTON4), TRUE);
					break;

				case IDC_BUTTON4:
					RewriteStateFile(szSaveFileName);
					MessageBox(NULL, "݊", TITLE_LINE, MB_OK);
					break;

				case IDC_BUTTON5:		// About...{^
					/* About̃_CAOo */
					DialogBox(hInst, "AboutBox", hWnd, (DLGPROC)About);
					break;

				case IDCANCEL:	// I{^
					DestroyWindow(hWnd);
					PostQuitMessage(0);
					break;

			}
			break;
	}
	return (FALSE);
}
#pragma warn .par

#pragma warn -par
/** AboutBox_CAO{ OK{^ꂽIBȊO͉Ȃ **/
BOOL CALLBACK _export About(HWND hDlg, unsigned message, WORD wParam,
		LONG lParam)
{

	switch (message) {

		/** ڑĨbZ[W **/
		case WM_COMMAND:
			if (wParam == IDOK) {
				EndDialog(hDlg, TRUE);
				return (FALSE);
			}
			break;

		default:
			return(FALSE);
    }
	return (TRUE);
}
// 2022-01-05 add start
BOOL CALLBACK _export MessageProc(HWND hDlg, unsigned message, WORD wParam,
		LONG lParam)
{

	switch (message) {
		case WM_INITDIALOG:
			SetDlgItemText(hDlg, IDC_EDIT5, mbuf);
			break;

		/** ڑĨbZ[W **/
		case WM_COMMAND:
			if (wParam == IDOK) {
				EndDialog(hDlg, TRUE);
				return (FALSE);
			}
			break;

		default:
			return(FALSE);
    }
	return (TRUE);
}
// 2022-01-05 add end
#pragma warn .par

/**  WindowsCGg...NƂsB C_CAOoďIB**/
#pragma warn -par
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{
	hInst = hInstance;
	return (DialogBox(hInst, "MainDialog", NULL, (DLGPROC)MainProc));
}
#pragma warn .par
/** ========================= End of Source ============================== **/
